// common
+ (bool) init:(NSString *)server ofAppKey:(NSString*)appName withVersion:(NSString*)appVersion;
+ (bool) init:(NSString *)server ofAppKey:(NSString*)appName withVersion:(NSString*)appVersion enableSyncStart:(bool)syncFlag;
+ (bool) init:(NSString *)server ofAppKey:(NSString*)appName withVersion:(NSString*)appVersion forUserId:(NSString*)userId;
+ (bool) init:(NSString *)server ofAppKey:(NSString*)appName withVersion:(NSString*)appVersion forUserId:(NSString*)userId enableSyncStart:(bool)syncFlag;

+ (bool) init:(NSString *)server ofAppKey:(NSString*)appName withVersion:(NSString*)appVersion forUserId:(NSString*)userId forHandleId:(NSString*)handleId;
+ (bool) init:(NSString *)server ofAppKey:(NSString*)appName withVersion:(NSString*)appVersion forUserId:(NSString*)userId forHandleId:(NSString*)handleId enableSyncStart:(bool)syncFlag;

+ (bool) init:(NSString *)server onPort:(int)port ofAppKey:(NSString*)appKey withVersion:(NSString*)version;
+ (bool) init:(NSString *)server onPort:(int)port ofAppKey:(NSString*)appKey withVersion:(NSString*)version enableSyncStart:(bool)syncFlag;
+ (bool) init:(NSString *)server onPort:(int)port ofAppKey:(NSString*)appKey withVersion:(NSString*)version forUserId:(NSString*)userId;
+ (bool) init:(NSString *)server onPort:(int)port ofAppKey:(NSString*)appKey withVersion:(NSString*)version forUserId:(NSString*)userId enableSyncStart:(bool)syncFlag;

+ (bool) init:(NSString *)server onPort:(int)port ofAppKey:(NSString*)appKey withVersion:(NSString*)version forUserId:(NSString*)userId forHandleId:(NSString*)handleId;
+ (bool) init:(NSString *)server onPort:(int)port ofAppKey:(NSString*)appKey withVersion:(NSString*)version forUserId:(NSString*)userId forHandleId:(NSString*)handleId enableSyncStart:(bool)syncFlag;

+ (void) debug:(NSString*)errorCode withMessage:(NSString*)message;
+ (void) error:(NSString*)errorCode withMessage:(NSString*)message;
+ (void) fatal:(NSString*)errorCode withMessage:(NSString*)message;
+ (void) info:(NSString*)errorCode withMessage:(NSString*)message;
+ (void) warn:(NSString*)errorCode withMessage:(NSString*)message;

+ (void) debug:(NSString*)errorCode withMessage:(NSString*)message atLocation:(NSString*)location;
+ (void) error:(NSString*)errorCode withMessage:(NSString*)message atLocation:(NSString*)location;
+ (void) fatal:(NSString*)errorCode withMessage:(NSString*)message atLocation:(NSString*)location;
+ (void) info:(NSString*)errorCode withMessage:(NSString*)message atLocation:(NSString*)location;
+ (void) warn:(NSString*)errorCode withMessage:(NSString*)message atLocation:(NSString*)location;

+ (void) setDebugMode:(bool)flag;

+ (void) removeAllCustomFields;
+ (void) removeCustomFieldForKey:(NSString*)key;
+ (void) setCustomField:(NSString*)value forKey:(NSString*)key;
+ (void) startSendThread;

+ (void) setUserId:(NSString*)userId;
+ (void) setLogType:(NSString*)logType;
+ (void) setLogSource:(NSString*) logSource;
+ (void) setCrashBlock:(void (^)(void))block;
+ (void) setLogDeduplicate:(bool)flag;

+ (void) enableHost:(bool)flag;

+ (int) queueSize;
+ (int) fileQueueSize;
