// unity
#ifdef __cplusplus
extern "C" {
#endif
    void UnitySendMessage(const char* obj, const char* method, const char* msg);
#ifdef __cplusplus
}
#endif

// for unity
+ (void) handledDebug:(NSString*)message withException:(NSString*)exception;
+ (void) handledError:(NSString*)message withException:(NSString*)exception;
+ (void) handledFatal:(NSString*)message withException:(NSString*)exception;
+ (void) handledInfo:(NSString*)message withException:(NSString*)exception;
+ (void) handledWarn:(NSString*)message withException:(NSString*)exception;

+ (void) sendUnityCrash:(NSString*)logLevel withType:(NSString*)logType withMessage:(NSString*)message withException:(NSString*)exception;

+ (bool) init:(NSString *)server onPort:(int)port byProtocol:(TLCLogProtocol)protocol ofAppKey:(NSString*)appName withVersion:(NSString*)appVersion forUserId:(NSString*)userId;
+ (bool) init:(NSString *)server onPort:(int)port byProtocol:(TLCLogProtocol)protocol ofAppKey:(NSString*)appName withVersion:(NSString*)appVersion forUserId:(NSString*)userId enablePlcrashreporter:(bool)flag;
+ (bool) init:(NSString *)server onPort:(int)port byProtocol:(TLCLogProtocol)protocol ofAppKey:(NSString*)appName withVersion:(NSString*)appVersion forUserId:(NSString*)userId enablePlcrashreporter:(bool)flag enableSyncStart:(bool)syncFlag;
+ (bool) init:(NSString *)server onPort:(int)port byProtocol:(TLCLogProtocol)protocol ofAppKey:(NSString*)appName withVersion:(NSString*)appVersion forUserId:(NSString*)userId enablePlcrashreporter:(bool)flag enableSyncStart:(bool)syncFlag withUnityVersion:(NSString*)UnityVersion;
+ (bool) init:(NSString *)server onPort:(int)port byProtocol:(TLCLogProtocol)protocol ofAppKey:(NSString*)appName withVersion:(NSString*)appVersion forUserId:(NSString*)userId enablePlcrashreporter:(bool)flag enableSyncStart:(bool)syncFlag withUnityVersion:(NSString*)UnityVersion forHandleId:(NSString*)handleId;
